#!/bin/sh

log="`pwd`/agents_watcher.log" 

kill_hangup ()
{
    echo `date` - $agent $pid $etime killing... >> $log
    kill -9 $pid >> $log
}

agents="Fetcher.py ReplicaResolver.py MoverPartitioner.py MoverManager.py Mover.py ReplicaVerifier.py BlockVerifier.py"
for agent in $agents; do
    pidlist=`ps -f -C 'python' | grep $agent | awk '{print \$2}'`
    if [ -n "$pidlist" ]; then
	for pid in $pidlist; do
	    etime=`ps h -p $pid -o etime`
### 	    echo $agent $pid $etime
	    if [ "`echo $etime | awk '/[0-9]:[0-9]+:[0-9]/'`" != "" ]; then
		# any non-Fetcher agent takes more than one hour
		if [ "$agent" != "Fetcher.py" ]; then
		    kill_hangup $agent $pid $etime $log
		    continue
		fi
		dayhour=`echo $etime | cut -d":" -f1`
		if [ "`echo $dayhour | awk '/[0-9]-[0-9]/'`" != "" ]; then
                    kill_hangup $agent $pid $etime $log
		elif [ $dayhour -ge 2 ]; then
                    kill_hangup $agent $pid $etime $log
		fi
	    fi
	done
    fi
done
